
struct facestruct {
	int ecount;
	int (*e)[2];
	double n[3];	//	normal
	double sn[3];	// normal after transformation
	double colour[3];
	double diffuse, spec;
	int specpower;

	//	extra info:
	//struct objstruct *o;	// owner
	char hidden;	//self-hidden

	double min[3];	// bounding box
	double max[3];
};

int main() {
	struct facestruct f;


	return(0);
}

char inface(double v[3], struct facestruct *f) {
	double x, nx;
	double y, ny;
	int a, b;
	int sh, nsh, nc;
	int i;

	// eliminate a coordinate - we find which component of the
	// normal is largest and eliminate this
	// a, b are the coords we keep
	a = 1;
	b = 2;
	if (f->n[1] > f->n[0]) {
		a = 0;
		if (f->n[2] > f->n[1]) {
			b = 1;
		}
	} else if (f->n[2] > f->n[0]) {
		a = 0;
		b = 1;
	}
	
	// translate so that v is the origin
	x = svertex[f->e[0][0]][a] - v[a];
	y = svertex[f->e[0][0]][b] - v[b];
	sh = (y >= 0 ? 1 : -1);

		printf("vertex:%lf %lf\n", v[a], v[b]);

	// init no. of crossings
	nc = 0;
	for (i=1; i<f->ecount; i++) {
		printf("%lf %lf\n", x, y);
		ny = svertex[f->e[i][0]][b] - v[b];
		nsh = (ny >= 0 ? 1 : -1);
		if (nsh != sh) {
			nx = svertex[f->e[i][0]][a] - v[a];
			if ((x>0) && (nx>0)) {
				nc++;
			} else if ((x>0) || (nx>0)) {
				if (x - ny*(nx-x)/(ny-y) > 0) nc++;
			}

		}
		sh = nsh;
		x = nx;
		y = ny;
	}

		ny = svertex[f->e[0][0]][b] - v[b];
		nsh = (ny >= 0 ? 1 : -1);
		if (nsh != sh) {
			nx = svertex[f->e[0][0]][a] - v[a];
			if ((x>0) && (nx>0)) {
				nc++;
			} else if ((x>0) || (nx>0)) {
				if (x - ny*(nx-x)/(ny-y) > 0) nc++;
			}

		}
	
	if (nc % 2) return(0);
	else return(1);
}
